/// <reference types="node" />
import { Server } from "http";
import { Server as SecureServer } from "https";
import { Optional } from "typescript-optional";
import { Config as SshConfig } from "node-ssh";
import { Express } from "express";
import { IPluginLedgerConnector, IWebServiceEndpoint, IPluginWebService, PluginAspect, ICactusPluginOptions, ConsensusAlgorithmFamily } from "@hyperledger/cactus-core-api";
import { LogLevelDesc } from "@hyperledger/cactus-common";
export interface IPluginLedgerConnectorCordaOptions extends ICactusPluginOptions {
    logLevel?: LogLevelDesc;
    sshConfigAdminShell: SshConfig;
    corDappsDir: string;
    cordaStartCmd?: string;
    cordaStopCmd?: string;
}
export declare class PluginLedgerConnectorCorda implements IPluginLedgerConnector<any, any, any, any>, IPluginWebService {
    readonly options: IPluginLedgerConnectorCordaOptions;
    static readonly CLASS_NAME = "DeployContractJarsEndpoint";
    private readonly instanceId;
    private readonly log;
    get className(): string;
    private httpServer;
    constructor(options: IPluginLedgerConnectorCordaOptions);
    getConsensusAlgorithmFamily(): Promise<ConsensusAlgorithmFamily>;
    getAspect(): PluginAspect;
    getInstanceId(): string;
    getPackageName(): string;
    deployContract(): Promise<any>;
    transact(): Promise<any>;
    installWebServices(expressApp: Express): Promise<IWebServiceEndpoint[]>;
    getHttpServer(): Optional<Server | SecureServer>;
    shutdown(): Promise<void>;
    getFlowList(): Promise<string[]>;
}
